//	Funkwecker 0.0

//	*******************************************************************
//	UNFERTIG! CHAOTISCH! BUGGY! INEFFIZIENT! - Entwicklung abgebrochen!
//	*******************************************************************

//	Copyright(C) 2009 Paul Wilhelm <paul@mosfetkiller.de>
//	http://mosfetkiller.de/?s=funkwecker

//	Compiler-Optimierungen müssen ausgeschaltet sein (Makefile benutzen)
//	Compiler optimizations must not be used (use Makefile)

//	Der gesamte Code ist recht ineffizient und ein wenig chaotisch an manchen Stellen
//	Whole code is quite inefficient and slightly chaotic here and there

#include "main.h"

int main(void)
{
	//	Initialisieren
	init_main();

	//	Normale Anzeigeeigenschaften
	char display_mode = 1;
	set_display_mode(display_mode);

	//	Modus = Zeitanzeige
	char display_function = 0;

	display_brightness = 0;

	set_bit(PORTC, 5);


	unsigned char dcf77_counter = 0, dcf77_reset_counter = 0, dcf77_lastreset_counter = 0;
	unsigned char dcf77_bit_counter = 0, dcf77_bits[8], dcf77_receiving = TRUE, dcf77_syncd = FALSE;

	while (dcf77_receiving)
	{

		dcf77_lastreset_counter++;

		if (!bit_is_set(PIND, 7))
		{
			if (dcf77_counter > 0) dcf77_counter--;
		}
		else
		{
			dcf77_counter++;
		}

		if (dcf77_counter >= DCF77_COUNTER_THRESHOLD)
		{
			dcf77_counter = 0;
			dcf77_reset_counter++;
			dcf77_lastreset_counter = 0;
		}

		if (dcf77_lastreset_counter >= DCF77_LEVEL_THRESHOLD)
		{
			if (dcf77_reset_counter == 1)
			{
				//	DCF77 Low
				dcf77_bits[(dcf77_bit_counter / 8)] = (1 << (dcf77_bit_counter % 8));	//	Bit speichern
				dcf77_bit_counter++;	//	Nächstes Bit auswählen
			}
			else if (dcf77_reset_counter == 2)
			{
				//	DCF77 High
				dcf77_bits[(dcf77_bit_counter / 8)] = (1 << (dcf77_bit_counter % 8));	//	Bit speichern
				dcf77_bit_counter++;	//	Nächstes Bit auswählen
			}
			else
			{
				//	Fehler!
				dcf77_syncd = FALSE;	//	Sync-Flag sicherheitshalber wieder löschen...
				dcf77_bit_counter = 0;	//	...und den Bitzähler auf Null setzen
			}

			dcf77_reset_counter = 0;
		}

		//	Übertragung komplett?
		if (dcf77_bit_counter == 60 && dcf77_syncd)
		{
			dcf77_receiving = FALSE;	//	Empfang beenden
		}

		//	DCF77 Sync
		if (dcf77_lastreset_counter >= DCF77_SYNC_THRESHOLD && dcf77_receiving)
		{
			dcf77_lastreset_counter = 0;

			dcf77_syncd = TRUE;	//	Sync-Flag setzen - Empfang beginnt jetzt
			dcf77_bit_counter = 0;	//	Bitzähler auf Null setzen
		}

	}



	while(1);


	//	Hauptschleife
	while (1)
	{

		//if  set_bit(PORTC, 5); else clear_bit(PORTC, 5);

		//	Was soll angezeigt werden?
		if (display_function == 0)

		//	Normale Zeitanzeige
		{
			display_time(hours, minutes);
		}
		else if (display_function == 1)

		//	Sekundenanzeige
		{
			char char1 = seconds / 10;
			char char2 = seconds - char1 * 10;

			display(10, char1, char2, 10);
		}
		else if (display_function == 2)

		//	Datum
		{
			display_time(13, 9);
		}



		//	Mit den beiden Tastern kann durch die Anzeige geblättert werden
		if (((button_forth_counter > 10) && (button_back_counter == 0)) || ((button_back_counter > 10) && (button_forth_counter == 0)))
		{

			//	Vor
			if ((button_forth_counter > 10) && (button_back_counter == 0))
			{
				loop_until_bit_is_set(PIND, 1);
				button_forth_counter = 0;
				if (display_function < 2) display_function++; else display_function = 0;
			}
			else if ((button_back_counter > 10) && (button_forth_counter == 0))
			//	Zurück
			{
				loop_until_bit_is_set(PIND, 2);
				button_back_counter = 0;
				if (display_function > 0) display_function--; else display_function = 1;
			}

			//	Anzeigeeigenschaften umstellen
			if (display_function == 0)

			//	Normale Zeitanzeige
			{
				display_blink_off(0);
				display_blink_off(3);

				display_dot_blink = 1;
				dots(0, 0, 0, 0);
			}
			else if (display_function == 1)

			//	Sekundenanzeige
			{
				display_dot_blink = 0;
				dots(0, 0, 0, 0);

				display_blink_on(0);
				display_blink_on(3);

				//	Darauf achten, dass die Striche um die Sekundenanzeige nicht im "Offbeat" blinken
				display_content[0][1] = 1;
				display_content[3][1] = 1;

				if (time_counter < 50)
				{
					display_content[0][2] = 0;
					display_content[3][2] = 0;
				}
			}
			else if (display_function == 2)

			//	Datum
			{
				display_blink_off(0);
				display_blink_off(3);

				display_dot_blink = 0;
				dots(0, 1, 0, 0);
			}

		}



		//	Druck auf den Button im normalen Betrieb toggelt Anzeigeeigenschaften des Displays
		//		1) Normal:		Grüne LED an, Rote LED aus, Punkt blinkt, Displayhelligkeit = 100
		//		2) Schlaf 1:	Grüne LED aus, Rote LED aus, Punkt blinkt nicht, schwellende Helligkeit
		//		3) Schlaf 2:	Grüne LED aus, Rote LED aus, Punkt blinkt nicht, Displayhelligkeit = 20
		if (bit_is_clear(PIND, 6))
		{
			loop_until_bit_is_set(PIND, 6);

			//	Schlaf
			if (display_mode < 3) display_mode++; else display_mode = 1;
			set_display_mode(display_mode);
		}



		//	Auf Alarme prüfen
		for (unsigned char i = 0; i < 9; i++)
		{
			//	MÖÖÖÖÖÖÖÖÖÖÖÖÖÖÖÖÖÖÖP! Alarm! (Innerhalb der ersten 3 Sekunden einer neuen Minute auslösen.)
			if ((hours == alarm[i][0]) && (minutes == alarm[i][1]) && (seconds < 3) && (alarm[i][2] == 1))
			{
				unsigned char old_display_mode = display_mode;
				set_display_mode(1);

				alarm_tone = 1;

				unsigned char seconds_start = seconds - 1;

				//	Auf Buttondruck bzw. eine Minute lang warten, dann Alarm wieder ausschalten
				while (alarm_tone > 0)
				{
					if (bit_is_clear(PIND, 6) || (seconds == seconds_start)) alarm_tone = 0;
				}

				loop_until_bit_is_set(PIND, 6);

				display_mode = old_display_mode;
				set_display_mode(display_mode);
			}
		}



 		//	Menükombination (beide Taster gleichzeitig für 2 Sekunden gedrückt) erkennen

 		//	IM MENÜ TRETEN KEINE ALARME AUF!

 		if ((button_back_counter >= 100 * 2) && (button_forth_counter >= 100 * 2))
 		{
 			alarm_tone = 0;

 			//	Menü-Anzeigemodus
			set_display_mode(0);



			//	Mit den Tastern kann man durch das Menü blättern,
			//	mit dem Button wird die Auswahl bestätigt,
			//	mit der Menükombination kann man das Menü wieder verlassen
			char menu = 0;
			char select = -1;
 			while (select < 1)
 			{

 				if (menu == 0)
 				//	ALAr	(Alarm)
 				{
					display(11, 12, 11, 15);
				}
				else if (menu == 1)
				//	SEt		(Set Clock)
				{
					display(5, 16, 17, -1);
				}
				else if (menu == 2)
				//	OPt		(Optionen)
				{
					display(0, 18, 17, -1);
				}

				//	Beim ersten Schleifendurchlauf auf Loslassen der Menükombination warten
				if (select == -1)
				{
					select = 0;
					loop_until_bit_is_set(PIND, 1);
					loop_until_bit_is_set(PIND, 2);
 					button_back_counter = button_forth_counter = 0;
				}



				//	Vor
				if (button_forth_counter > 0 && button_back_counter == 0)
				{
					loop_until_bit_is_set(PIND, 1);
					button_forth_counter = 0;
					if (menu < 2) menu++;
				}

				//	Zurück
				if (button_back_counter > 10 && button_forth_counter == 0)
				{
					loop_until_bit_is_set(PIND, 2);
					button_back_counter = 0;
					if (menu > 0) menu--;
				}

 				//	Button
 				if (bit_is_clear(PIND, 6))
 				{
 					loop_until_bit_is_set(PIND, 6);
					select = 1;
				}

		 		if ((button_back_counter >= 100 * 2) && (button_forth_counter >= 100 * 2))
				{
		 			button_back_counter = button_forth_counter = 0;
		 			select = -1;
		 		}
			}



			if (menu == 0)
			{
				//	Alarm-Menü
				unsigned char alarm_num = 0;

				//	Die letzte Stelle blinken lassen
				display_blink_on(3);

				//	Mit den Tastern kann man die Alarmnummer von 0 bis 9 auswählen,
				//	mit dem Button wird die Auswahl bestätigt
				select = 0;
				while (select == 0)
				{
					display(11, 12, -1, alarm_num);

					//	Vor
					if (button_forth_counter > 0)
					{
						loop_until_bit_is_set(PIND, 1);
						button_forth_counter = 0;
						if (alarm_num < 9) alarm_num++; else alarm_num = 0;
					}

					//	Zurück
					if (button_back_counter > 0)
					{
						loop_until_bit_is_set(PIND, 2);
						button_back_counter = 0;
						if (alarm_num > 0) alarm_num--; else alarm_num = 9;
					}

					//	Button
					if (bit_is_clear(PIND, 6))
					{
						loop_until_bit_is_set(PIND, 6);
						select = 1;
					}
				}

				display_blink_off(3);

				//	Mit den Tastern kann man zwischen On (vorderer Taster) und Off (hinterer Taster) wählen,
				//	mit dem Button wird die Auswahl bestätigt
				select = 0;
				char choice = alarm[alarm_num][2];
				while (select == 0)
				{
					if (choice == 1)
						display(0, 13, -1, -1);	//	ON
					else
						display(0, 14, 14, -1);	//	OFF

					//	Vor (Alarm an)
					if (button_forth_counter > 0)
					{
						loop_until_bit_is_set(PIND, 1);
						button_forth_counter = 0;
						choice = alarm[alarm_num][2] = 1;
					}

					//	Zurück (Alarm aus)
					if (button_back_counter > 0)
					{
						loop_until_bit_is_set(PIND, 2);
						button_back_counter = 0;
						choice = alarm[alarm_num][2] = 0;
					}

					//	Button
					if (bit_is_clear(PIND, 6))
					{
						loop_until_bit_is_set(PIND, 6);
						select = 1;
					}
				}

				//	Wurde der Alarm angeschaltet, kann man nun die Alarmzeit einstellen,
				//	ansonsten wird das Menü beendet
				if (choice == 1)
				{
					user_get_time(&alarm[alarm_num][0], 23, &alarm[alarm_num][1], 59);
					save_alarms();
				}

			}
			else if (menu == 1)


			//	Uhrzeit manuell setzen
			{
				user_get_time((unsigned char*)&hours, 23, (unsigned char*)&minutes, 59);
			}

			//	Vorheriger Anzeigemodus
			set_display_mode(display_mode);
 		}
	}
}



void init_main()
{
	time_counter = 0;
	display_dot_blink = 2;
	display_fade = 0;

	//	Zählen die Tastdauer der beiden Taster (10ms Auflösung)
	//	++ bei gedrücktem Taster und -- bei nicht gedrücktem Taster
	//	(min. 0, max. 65535)
	button_back_counter = 0;
	button_forth_counter = 0;

	display_multiplexer = 0;
	display_pwm_counter = 0;
	display_brightness = 100;
	led_green = 0;
	led_red = 0;

	//	Uhrzeit auf 0:00.00 setzen
	seconds = 0;
	minutes = 0;
	hours = 0;

	//	Display initialisieren
	init_display();

	//	Alarme initialisieren
	init_alarms();



	//	Dies füllt den Alarmspeicher im internen EEPROM mit deaktivierten Alarmen von 6:00 bis 15:00,
	//	sollte einmalig ausgeführt werden, ansonsten ist der AVR mit den uninitialisierten EEPROM-Werten verwirrt

	//	wipe_alarms();



	//	Richtungsregister und PullUp-Widerstände setzen
	DDRB =	0b111111;
	PORTB =	0b000000;

	DDRC =	0b111111;
	PORTC =	0b000000;

	DDRD =	0b00111001;
	PORTD =	0b01000110;	//	Bit 7: DCF77-Pull-Up (aus)

	//	Display-Interrupt vorbereiten (TIMER0)
	TCCR0 = (1 << CS02) * 0 + (1 << CS01) * 0 + (1 << CS00) * 1;	//	Prescaler 1
	TCNT0 = 0;

	//	Zeit-Interrupt vorbereiten (TIMER1)
	TCCR1B = (1 << CS12) * 0 + (1 << CS11) * 0 + (1 << CS10) * 1 + (1 << WGM12);	//	Prescaler 1, CTC
	OCR1A = F_CPU / 1 / 100;	//	10ms Auflösung
	TCNT1 = 0;

	//	Beide Interrupts einschalten
	TIMSK = (1 << TOIE0) | (1 << OCIE1A);
	sei();
}
