#include "main.h"
#include "user.h"

void user_get_time(unsigned char* value1, unsigned char limit1, unsigned char* value2, unsigned char limit2)
{
	//	Linke Stellen blinken lassen
	display_blink_on(0);
	display_blink_on(1);

	//	Punkt einschalten
	dots(0, 1, 0, 0);

	//	Mit den Tastern kann man den Wert verändern, mit dem Button wird die Auswahl bestätigt
	//	Langer Druck auf Taster lässt Werte in 10er-Schritten bis an die Intervallgrenzen springen
	char select = 0;
	while (select == 0)
	{

		//	Beide Werte anzeigen
		display_time(*value1, *value2);

		//	Vor
		if (button_forth_counter > 0)
		{
			button_forth_counter = 0;
			if (*value1 < limit1) *value1 += 1; else *value1 = 0;

			unsigned int buttontime = 100;
			while (!bit_is_set(PIND, 1))
			{
				display_time(*value1, *value2);

				if (button_forth_counter >= buttontime)
				{
					display_blink_off(0);
					display_blink_off(1);

					if ((*value1 + 10) < limit1) *value1 += 10; else { *value1 = limit1; }

					button_forth_counter = 0;
					buttontime = 50;
				}
			}

			if (buttontime == 50)
			{
				display_blink_on(0);
				display_blink_on(1);
			}

			loop_until_bit_is_set(PIND, 1);
			button_forth_counter = 0;
		}

		//	Zurück
		if (button_back_counter > 0)
		{
			button_back_counter = 0;
			if (*value1 > 0) *value1 -= 1; else *value1 = limit1;

			unsigned int buttontime = 100;
			while (!bit_is_set(PIND, 2))
			{
				display_time(*value1, *value2);

				if (button_back_counter >= buttontime)
				{
					display_blink_off(0);
					display_blink_off(1);

					if ((*value1 - 10) > 0) *value1 -= 10; else { *value1 = 0; }

					button_back_counter = 0;
					buttontime = 50;
				}
			}

			if (buttontime == 50)
			{
				display_blink_on(0);
				display_blink_on(1);
			}

			loop_until_bit_is_set(PIND, 2);
			button_back_counter = 0;
		}

		//	Button
		if (bit_is_clear(PIND, 6))
		{
			loop_until_bit_is_set(PIND, 6);
			select = 1;
		}
	}

	//	Schluss mit dem Geblinke hier!
	display_blink_off(0);
	display_blink_off(1);



	//	Exakt der gleiche Code wie oben, nur mit den beiden anderen Variablen
	//	Muss optimiert werden!


	//	Rechte Stellen blinken lassen
	display_blink_on(2);
	display_blink_on(3);

	//	Mit den Tastern kann man den Wert verändern, mit dem Button wird die Auswahl bestätigt
	//	Langer Druck auf Taster lässt Werte in 10er-Schritten bis an die Intervallgrenzen springen
	select = 0;
	while (select == 0)
	{

		//	Beide Werte anzeigen
		display_time(*value1, *value2);

		//	Vor
		if (button_forth_counter > 0)
		{
			button_forth_counter = 0;
			if (*value2 < limit2) *value2 += 1; else *value2 = 0;

			unsigned int buttontime = 100;
			while (!bit_is_set(PIND, 1))
			{
				display_time(*value1, *value2);

				if (button_forth_counter >= buttontime)
				{
					display_blink_off(2);
					display_blink_off(3);

					if ((*value2 + 10) < limit2) *value2 += 10; else { *value2 = limit2; }

					button_forth_counter = 0;
					buttontime = 50;
				}
			}

			if (buttontime == 50)
			{
				display_blink_on(2);
				display_blink_on(3);
			}

			loop_until_bit_is_set(PIND, 1);
			button_forth_counter = 0;
		}

		//	Zurück
		if (button_back_counter > 0)
		{
			button_back_counter = 0;
			if (*value2 > 0) *value2 -= 1; else *value2 = limit2;

			unsigned int buttontime = 100;
			while (!bit_is_set(PIND, 2))
			{
				display_time(*value1, *value2);

				if (button_back_counter >= buttontime)
				{
					display_blink_off(2);
					display_blink_off(3);

					if ((*value2 - 10) > 0) *value2 -= 10; else { *value2 = 0; }

					button_back_counter = 0;
					buttontime = 50;
				}
			}

			if (buttontime == 50)
			{
				display_blink_on(2);
				display_blink_on(3);
			}

			loop_until_bit_is_set(PIND, 2);
			button_back_counter = 0;
		}

		//	Button
		if (bit_is_clear(PIND, 6))
		{
			loop_until_bit_is_set(PIND, 6);
			select = 1;
		}
	}

	//	Schluss mit dem Geblinke hier!
	display_blink_off(2);
	display_blink_off(3);

}
